/*
 *  File:       spells4.cc
 *  Summary:    Yet More Spell Function Declarations
 *  Written by: Josh Fishman
 *
 *  Change History (most recent first):
 *
 * <1> 07jan2000  jmf  Created
 */


#ifndef SPELLS4_H
#define SPELLS4_H


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: beam
 * *********************************************************************** */
int backlight_monsters(char x, char y, int pow, int garbage);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spells1 - spells4
 * *********************************************************************** */
int make_a_normal_cloud(char x, char y, int pow, int ctype);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: effects
 * *********************************************************************** */
int torment_monsters(char x, char y, int pow, int message);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spells1 - spells4
 * *********************************************************************** */
void apply_area_cloud( int (*func)(char,char,int,int), char x, char y, int pow, int number, int ctype);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: effects - spells4
 * *********************************************************************** */
void apply_area_within_radius(int (*func)(char,char,int,int), char x, char y, int pow, int radius, int ctype);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_bend(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell - spells1
 * *********************************************************************** */
void cast_condensation_shield(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_detect_secret_doors(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_discharge(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_evaporate(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell - spells1
 * *********************************************************************** */
void cast_forescry(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_fragmentation(int powc);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: ability - spell
 * *********************************************************************** */
#ifdef USE_ELVISH_GLAMOUR_ABILITY
void cast_glamour(int pow);
#endif


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_ignite_poison(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_intoxicate(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_mass_sleep(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_passwall(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: ability - spell
 * *********************************************************************** */
void cast_rotting(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_sandblast(int powc);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell - spells1
 * *********************************************************************** */
void cast_see_invisible(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell - spells1
 * *********************************************************************** */
void cast_semi_controlled_blink(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_shatter(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: ability - spell
 * *********************************************************************** */
void cast_shuggoth_seed(int powc);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell - spells1
 * *********************************************************************** */
void cast_silence(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_sticks_to_snakes(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_summon_butterflies(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_summon_dragon(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void summon_large_mammal(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_tame_beasts(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: spell
 * *********************************************************************** */
void cast_warp_field(int pow);


// last updated 21may2000 {dlb}
/* ***********************************************************************
 * called from: acr
 * *********************************************************************** */
void make_shuggoth(char x, char y, int hp);


#endif
